/* Copyright(C) 2004-2005 Brazil

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/  
#ifndef _SEN_SNIP_H
#define _SEN_SNIP_H

#ifndef _SENNA_H
#include "senna_in.h"
#endif  /* _SENNA_H */

/* #define TBM 1 */
#define QUICK 1
#define ASIZE 256                /* character-set size */

#ifdef  __cplusplus
extern "C"
{
#endif

#include "str.h"

typedef struct __snip_cond 
{
  const char *opentag;
  const char *closetag;
  size_t opentag_len;
  size_t closetag_len;
  size_t keyword_len;
  sen_nstr * keyword;
#ifdef TBM
  size_t bmBc[ASIZE];
  size_t *bmGs;
#endif /* TBM */
#ifdef QUICK
  size_t qsBc[ASIZE];
#endif /* QUICK */
  struct __snip_cond *next;

  int count;
} _snip_cond;
typedef struct 
{
  size_t start_offset;
  size_t end_offset;
  _snip_cond * cond;
} _bm_search_result;
typedef struct 
{
  size_t start_offset;
  size_t end_offset;
  size_t tagged_len;
  float score;
  unsigned int first_cond_id;
} _snip_result;
struct _sen_snip
{
  sen_encoding encoding;
  int flags;
  size_t width;
  unsigned int max_results;
  const char *defaultopentag;
  const char *defaultclosetag;
  size_t defaultopentag_len;
  size_t defaultclosetag_len;

  sen_snip_mapping * mapping;

  _snip_cond * first_cond;
  _snip_cond * last_cond;
  unsigned int cond_len;

  unsigned int count;
  const char *string;
  sen_nstr * nstr;
  _bm_search_result * bmres;
  _snip_result * result;
};

#ifdef __cplusplus
} 
#endif

#endif  /* _SEN_SNIP_H */
